#include "dragon.h"

dragon::dragon(RNG *rng, const position &pos):
        character{rng, race::rdragon, pos} {
        gold = 0;
        hostile = true;
}

result dragon::attack(const direction dir, character_list &chlist) {
        position tmp{pos + MOVE[dir]};

        for (auto &ch : chlist)
                if (tmp == ch->get_position()) {
                        return ch->get_hit(race, ATK, base_hit_rate);
                }

        return result::fine;
}

result dragon::get_hit(const enum race &race, const int atk,
                       const fraction hitrate) {
        if (rng->trial(hitrate)) // This is a hit!
                HP = std::max(HP - calc_dmg(atk, DEF), 0);

        if (HP == 0)
                return result::died;

        return result::hit;
}

result dragon::move(const direction dir,
                    const position_list &available_positions) {
        return result::fine;
}
