#include "drow.h"
#include <algorithm>
#include <math.h>

drow::drow(RNG *rng, const position &pos):
        character{rng, race::rdrow, pos} {
        gold = 0;
        hostile = true;
}

result drow::attack(const direction dir, character_list &chlist) {
        position tmp{pos + MOVE[dir]};

        for (auto &ch : chlist)
                if (tmp == ch->get_position()) {
                        return ch->get_hit(race, ATK, base_hit_rate);
                }

        return result::fine;
}

result drow::get_hit(const enum race &race, const int atk,
                     const fraction hitrate) {
        if (rng->trial(hitrate))
                HP = std::max(HP - calc_dmg(atk, DEF), 0);

        if (HP == 0)
                return result::died;

        return result::hit;
}
