#ifndef __POSITION_H__
#define __POSITION_H__
#include <vector>

typedef struct position {
    int x;
    int y;

    position();
    position(int nx, int ny);

    position operator+(const position &other) const;
    position &operator=(const position &other);
    position &operator+=(const position &other);
    bool operator==(const position &other) const;
    bool operator!=(const position &other) const;
    bool operator<(const position &other) const;
} position;

std::size_t find(const std::vector<position> &sorted_list,
                 const position &target);

// requires: all elements of excluded are in sorted_positions
std::vector<position> remove_from_list(const std::vector<position>
                                       &sorted_positions,
                                       std::vector<position> excluded);
void remove_from_list(std::vector<position> &sorted_positions,
                      position &excluded);

float distance(const position &a, const position &b);
int distance_sqr(const position &a, const position &b);
bool is_adjacent(const position &a, const position &b);

#endif
